import _classCallCheck from "@babel/runtime/helpers/esm/classCallCheck";
import _createClass from "@babel/runtime/helpers/esm/createClass";
import _inherits from "@babel/runtime/helpers/esm/inherits";
import _createSuper from "@babel/runtime/helpers/esm/createSuper";
import { jsx } from '../../jsx';
import Component from '../../base/component';

var getPoint = function getPoint(cener, angle, r) {
  var x = cener.x + Math.cos(angle) * r;
  var y = cener.y + Math.sin(angle) * r;
  return {
    x: x,
    y: y
  };
};

var getTicks = function getTicks(start, end, tickCount) {
  var ticks = [];
  var diff = end - start;

  for (var i = 0; i <= tickCount; i++) {
    ticks.push(start + diff * i / tickCount);
  }

  return ticks;
};

var Guage = /*#__PURE__*/function (_Component) {
  _inherits(Guage, _Component);

  var _super = _createSuper(Guage);

  function Guage() {
    _classCallCheck(this, Guage);

    return _super.apply(this, arguments);
  }

  _createClass(Guage, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          center = _this$props.center,
          startAngle = _this$props.startAngle,
          endAngle = _this$props.endAngle,
          r = _this$props.r,
          percent = _this$props.percent,
          tickCount = _this$props.tickCount;
      var diff = endAngle - startAngle;
      var x = center.x,
          y = center.y;
      var ticks = getTicks(startAngle, endAngle, tickCount);
      return jsx("group", null, jsx("arc", {
        attrs: {
          x: x,
          y: y,
          r: r,
          startAngle: startAngle,
          endAngle: endAngle,
          lineWidth: '20px',
          lineCap: 'round',
          stroke: '#e7e7e7'
        }
      }), jsx("arc", {
        attrs: {
          x: x,
          y: y,
          r: r,
          startAngle: startAngle,
          endAngle: startAngle,
          lineWidth: '40px',
          lineCap: 'round',
          stroke: '#0075ff'
        },
        animation: {
          appear: {
            easing: 'linear',
            duration: 500,
            property: ['endAngle'],
            start: {
              endAngle: startAngle
            },
            end: {
              endAngle: startAngle + diff * percent
            }
          }
        }
      }), ticks.map(function (tick) {
        var start = getPoint(center, tick, 65);
        var end = getPoint(center, tick, 75);
        return jsx("line", {
          attrs: {
            x1: start.x,
            y1: start.y,
            x2: end.x,
            y2: end.y,
            lineWidth: '6px',
            lineCap: 'round',
            stroke: '#e7e7e7'
          }
        });
      }));
    }
  }]);

  return Guage;
}(Component);

export default Guage;