import Component from '../../base/component';
import Chart from '../../chart';
import { Style } from '../../types';
interface LegendItem {
    /**
     * 标记颜色。
     */
    color: string;
    /**
     * 名称。
     */
    name: string;
    /**
     * 值。
     */
    value?: string | number;
    /**
     * 图例标记。
     */
    marker?: string;
}
export interface LegendProps {
    /**
     * 代表图例对应的数据字段名。
     */
    field?: string;
    /**
     * 图表。
     */
    readonly chart?: Chart;
    /**
     * 图例的显示位置。默认为 top。
     */
    position?: 'right' | 'left' | 'top' | 'bottom';
    /**
     * 图例宽度
     */
    width?: number | string;
    /**
     * 图例高度
     */
    height?: number | string;
    /**
     * legend 和图表内容的间距
     */
    margin?: number | string;
    /**
     * 回调函数，用于格式化图例每项的文本显示。
     */
    itemFormatter?: (value: string) => string;
    /**
     * 图例项列表。
     */
    items?: LegendItem[];
    /**
     * 图例样式。
     */
    style?: Style;
    /**
     * 图例标记。
     */
    marker?: 'circle' | 'square';
}
declare const _default: (View: any) => {
    new (props: any): {
        style: Style;
        getOriginItems(): any;
        getItems(): any;
        getMaxItemBox(legendShape: any): {
            width: number;
            height: number;
        };
        _init(): void;
        updateCoord(): void;
        willMount(): void;
        didMount(): void;
        willUpdate(): void;
        _initEvent(): void;
        setItems(items: any): void;
        render(): JSX.Element;
        props: LegendProps;
        state: any;
        context: import("../../base/component").ComponentContext;
        refs: {
            [key: string]: Component<any, any>;
        };
        updater: import("../../base/component").Updater<any>;
        children: JSX.Element;
        container: any;
        animate: boolean;
        willReceiveProps(_props: LegendProps): void; /**
         * 回调函数，用于格式化图例每项的文本显示。
         */
        didUpdate(): void;
        didUnmount(): void;
        setState(partialState: any, callback?: () => void): void;
        forceUpdate(): void;
        setAnimate(animate: boolean): void;
    };
};
export default _default;
