import _objectSpread from "@babel/runtime/helpers/esm/objectSpread2";
import { jsx } from '../../jsx';
export default (function (props, context) {
  var sidePadding = props.sidePadding,
      lineStyle = props.lineStyle,
      anchorStyle = props.anchorStyle,
      labels = props.labels,
      label1OffsetY = props.label1OffsetY,
      label2OffsetY = props.label2OffsetY,
      triggerRef = props.triggerRef;
  var defaultTextAttrs = {
    x: 0,
    y: 0,
    fontSize: '24px',
    lineHeight: '24px',
    fill: '#808080'
  };
  return jsx("group", {
    ref: triggerRef
  }, labels.map(function (label) {
    var y = label.y,
        fill = label.fill,
        _inflection = label._inflection,
        _anchor = label._anchor,
        origin = label.origin,
        label1 = label.label1,
        label2 = label.label2;
    var lastPoint = {
      x: label._side === 'left' ? sidePadding : context.width - sidePadding,
      y: y
    };
    var textAttrs = {
      textAlign: label._side === 'left' ? 'left' : 'right',
      x: label._side === 'left' ? sidePadding : context.width - sidePadding
    };
    var points = [_anchor, _inflection, lastPoint];
    return jsx("group", null, jsx("circle", {
      attrs: _objectSpread({
        r: 2,
        x: _anchor.x,
        y: _anchor.y,
        fill: fill
      }, anchorStyle)
    }), jsx("polyline", {
      attrs: _objectSpread({
        points: points,
        lineWidth: 1,
        stroke: fill
      }, lineStyle)
    }), jsx("text", {
      className: "click",
      attrs: _objectSpread(_objectSpread(_objectSpread({}, defaultTextAttrs), {}, {
        textBaseline: 'bottom',
        y: y + label1OffsetY
      }, textAttrs), label1),
      data: origin
    }), jsx("text", {
      className: "click",
      attrs: _objectSpread(_objectSpread(_objectSpread({}, defaultTextAttrs), {}, {
        textBaseline: 'top',
        y: y + label2OffsetY
      }, textAttrs), label2),
      data: origin
    }));
  }));
});