import { jsx } from '../../jsx';
export default (function (props) {
  var coord = props.coord,
      node = props.node;
  var children = node.children;
  var _coord$center = coord.center,
      x = _coord$center.x,
      y = _coord$center.y;

  var renderNodes = function renderNodes(nodes) {
    return jsx("group", null, nodes.map(function (node) {
      var xMin = node.xMin,
          xMax = node.xMax,
          yMin = node.yMin,
          yMax = node.yMax,
          color = node.color,
          children = node.children;
      return jsx("group", null, jsx("sector", {
        attrs: {
          x: x,
          y: y,
          lineWidth: '1px',
          stroke: '#fff',
          startAngle: xMin,
          endAngle: xMax,
          r0: yMin,
          r: yMax,
          anticlockwise: false,
          fill: color
        }
      }), children && children.length ? renderNodes(children) : null);
    }));
  };

  return renderNodes(children);
});