import _objectSpread from "@babel/runtime/helpers/esm/objectSpread2";
import _classCallCheck from "@babel/runtime/helpers/esm/classCallCheck";
import _createClass from "@babel/runtime/helpers/esm/createClass";
import _inherits from "@babel/runtime/helpers/esm/inherits";
import _createSuper from "@babel/runtime/helpers/esm/createSuper";
import { jsx } from '../../jsx';
import { isArray, isFunction, find } from '@antv/util';
import Component from '../../base/component';
export default (function (View) {
  return /*#__PURE__*/function (_Component) {
    _inherits(Tooltip, _Component);

    var _super = _createSuper(Tooltip);

    function Tooltip(props) {
      var _this;

      _classCallCheck(this, Tooltip);

      _this = _super.call(this, props);
      _this.state = {
        records: null
      };
      return _this;
    }

    _createClass(Tooltip, [{
      key: "updateCoord",
      value: function updateCoord() {
        var props = this.props,
            context = this.context;
        var _props$padding = props.padding,
            padding = _props$padding === void 0 ? '10px' : _props$padding,
            chart = props.chart;
        chart.updateCoordFor(this, {
          position: 'top',
          width: 0,
          height: context.px2hd(padding)
        });
      }
    }, {
      key: "willMount",
      value: function willMount() {
        this.updateCoord();
      }
    }, {
      key: "didMount",
      value: function didMount() {
        var props = this.props;
        var chart = props.chart,
            defaultItem = props.defaultItem;

        if (defaultItem) {
          var point = chart.getPosition(defaultItem);
          this.show(point);
        }

        this._initEvent();
      }
    }, {
      key: "_initEvent",
      value: function _initEvent() {
        var _this2 = this;

        var context = this.context,
            props = this.props;
        var canvas = context.canvas;
        var _props$triggerOn = props.triggerOn,
            triggerOn = _props$triggerOn === void 0 ? 'press' : _props$triggerOn,
            _props$triggerOff = props.triggerOff,
            triggerOff = _props$triggerOff === void 0 ? 'pressend' : _props$triggerOff,
            _props$alwaysShow = props.alwaysShow,
            alwaysShow = _props$alwaysShow === void 0 ? false : _props$alwaysShow;
        canvas.on(triggerOn, function (ev) {
          var points = ev.points;

          _this2.show(points[0]);
        });
        canvas.on(triggerOff, function (_ev) {
          if (!alwaysShow) {
            _this2.hide();
          }
        });
      }
    }, {
      key: "show",
      value: function show(point) {
        var props = this.props;
        var chart = props.chart,
            coord = props.coord,
            onChange = props.onChange;
        var snapRecords = chart.getSnapRecords(point);
        if (!snapRecords || !snapRecords.length) return;
        var legendItems = chart.getLegendItems();
        var _snapRecords$ = snapRecords[0],
            origin = _snapRecords$.origin,
            xField = _snapRecords$.xField,
            yField = _snapRecords$.yField;
        var xScale = chart.getScale(xField);
        var yScale = chart.getScale(yField);
        var showPoint = coord.convertPoint({
          x: xScale.scale(origin[xField]),
          y: yScale.scale(origin[yField])
        });
        var records = snapRecords.map(function (record) {
          var origin = record.origin,
              xField = record.xField,
              yField = record.yField;
          var name = xScale.getText(origin[xField]);
          var value = yScale.getText(origin[yField]);

          if (legendItems && legendItems.length) {
            var item = find(legendItems, function (item) {
              var field = item.field,
                  tickValue = item.tickValue;
              return origin[field] === tickValue;
            });

            if (item && item.name) {
              name = item.name;
            }
          }

          return _objectSpread(_objectSpread({}, record), {}, {
            name: name,
            value: value
          });
        });

        if (!isArray(records) || !records.length) {
          return;
        }

        this.setState({
          point: showPoint,
          records: records
        });

        if (isFunction(onChange)) {
          onChange(records);
        }
      }
    }, {
      key: "hide",
      value: function hide() {
        this.setState({
          point: null,
          records: null
        });
      }
    }, {
      key: "render",
      value: function render() {
        var props = this.props,
            state = this.state;
        var visible = props.visible;

        if (visible === false) {
          return null;
        }

        var point = state.point,
            records = state.records;
        if (!records || !records.length) return null;
        return jsx(View, _objectSpread(_objectSpread({}, props), {}, {
          point: point,
          records: records
        }));
      }
    }]);

    return Tooltip;
  }(Component);
});