import _classCallCheck from "@babel/runtime/helpers/esm/classCallCheck";
import _createClass from "@babel/runtime/helpers/esm/createClass";
import { upperFirst } from '@antv/util';
import Context from './interaction/context';
import * as defaultInteractions from './interaction/index';

var interactionController = /*#__PURE__*/function () {
  function interactionController(chart) {
    _classCallCheck(this, interactionController);

    this.chart = chart;
    this.interactions = [];
  }

  _createClass(interactionController, [{
    key: "createInteraction",
    value: function createInteraction(type, cfg) {
      if (!type) {
        return null;
      }

      if (!this.context) {
        this.context = new Context(this.chart);
      }

      var Constructor = defaultInteractions[upperFirst(type)];

      if (!type || !Constructor) {
        return;
      }

      var chart = this.chart,
          context = this.context;
      var interaction = new Constructor(cfg, {
        chart: chart,
        context: context
      });
      this.interactions.push(interaction);
    }
  }, {
    key: "getInteractionContext",
    value: function getInteractionContext() {
      if (!this.context) {
        this.context = new Context(this.chart);
      }

      return this.context;
    }
  }]);

  return interactionController;
}();

export { interactionController as default };