import _classCallCheck from "@babel/runtime/helpers/esm/classCallCheck";
import _createClass from "@babel/runtime/helpers/esm/createClass";
import _assertThisInitialized from "@babel/runtime/helpers/esm/assertThisInitialized";
import _inherits from "@babel/runtime/helpers/esm/inherits";
import _createSuper from "@babel/runtime/helpers/esm/createSuper";
import Base from './base';
import { mix } from '@antv/util';
/**
 * 缩放
 */

var Pinch = /*#__PURE__*/function (_Base) {
  _inherits(Pinch, _Base);

  var _super = _createSuper(Pinch);

  function Pinch(cfg, chart) {
    var _this;

    _classCallCheck(this, Pinch);

    _this = _super.call(this, cfg, chart);

    var _assertThisInitialize = _assertThisInitialized(_this),
        context = _assertThisInitialize.context;

    mix(context, cfg);
    return _this;
  }

  _createClass(Pinch, [{
    key: "getDefaultCfg",
    value: function getDefaultCfg() {
      return {
        type: 'pinch',
        startEvent: 'pinchstart',
        processEvent: 'pinch',
        endEvent: 'pinchend'
      };
    }
  }, {
    key: "start",
    value: function start() {
      var context = this.context;
      context.start();
    }
  }, {
    key: "process",
    value: function process(e) {
      e.preventDefault && e.preventDefault();
      var zoom = e.zoom,
          center = e.center;
      var context = this.context;
      var chart = context.chart;
      var coord = chart.coord;
      var start = coord.start,
          end = coord.end;
      var coordWidth = end.x - start.x;
      var leftLen = Math.abs(center.x - start.x);
      var rightLen = Math.abs(end.x - center.x); // 计算左右缩放的比例

      var leftScale = leftLen / coordWidth;
      var rightScale = rightLen / coordWidth;
      context.doZoom(leftScale, rightScale, zoom);
    }
  }, {
    key: "end",
    value: function end() {
      // 缩放完成后再更新ticks
      var context = this.context;
      context.repaint();
    }
  }]);

  return Pinch;
}(Base);

export { Pinch as default };