import Layout from '../base/layout';
import { Range, Point, Option } from './types';
interface RectPoint {
    x: number | [number, number];
    y: number | [number, number];
    y0?: number;
    size?: number;
}
interface Rect {
    xMin: number;
    xMax: number;
    yMin: number;
    yMax: number;
}
/**
 * 直角坐标系
 * convert相关的方法，涉及将标准坐标系映射到实际坐标系内
 * transform相关的方法，是仅将某一种关键点转换成另一种关键点 (比如将x/y/size/y0转换成yMin/yMax/..)
 */
declare class Base extends Layout {
    type: string;
    isPolar: boolean;
    transposed: boolean;
    center: Point;
    x: Range;
    y: Range;
    constructor(option: Option);
    update(option: Option): this;
    isCyclic(): boolean;
    convertPoint(point: any): any;
    convertRect(rectPoint: RectPoint): Rect;
    transformToRect(rectPoint: RectPoint): Rect;
    invertPoint(point: any): any;
}
export default Base;
