import _classCallCheck from "@babel/runtime/helpers/esm/classCallCheck";
import _createClass from "@babel/runtime/helpers/esm/createClass";
import { isString, isObject } from '@antv/util';
import { Linear, Category, Identity } from '../attr';
import { isFunction } from '@antv/util';

var Attr = /*#__PURE__*/function () {
  function Attr() {
    _classCallCheck(this, Attr);
  }

  _createClass(Attr, [{
    key: "createAttrOption",
    value: function createAttrOption(option) {
      if (!option) return null;

      if (isString(option)) {
        return {
          field: option
        };
      }

      if (isObject(option)) {
        if (!option.field) {
          option.field = option;
        }
      }

      return option;
    }
  }, {
    key: "createAttr",
    value: function createAttr(option) {
      var type = option.type,
          scale = option.scale;
      var values = scale.values;
      var firstValue = values[0]; // identity

      if (scale && scale.type === 'identity') {
        return new Identity(option);
      } // linear & category


      var AttrConstructor = type ? type : typeof firstValue === 'number' ? Linear : Category;
      return new AttrConstructor(option);
    } // 设置属性映射的值域

  }, {
    key: "setAttrRange",
    value: function setAttrRange(attrName, range) {
      var attr = this.attrs[attrName];
      attr.range = range;
    } // 获取属性映射的值域

  }, {
    key: "getAttrRange",
    value: function getAttrRange(attrName) {
      var attr = this.attrs[attrName];
      if (!attr) return;
      return attr.range;
    }
  }, {
    key: "getAttr",
    value: function getAttr(attrName) {
      return this.attrs[attrName];
    }
  }, {
    key: "getAttrOption",
    value: function getAttrOption(attrName) {
      return this.attrOptions[attrName];
    }
  }, {
    key: "getAttrValue",
    value: function getAttrValue(attrName, record) {
      var attr = this.attrs[attrName];
      if (!attr) return null;
      var field = attr.field,
          callback = attr.callback,
          scale = attr.scale;

      if (scale.type === 'identity') {
        return attr.mapping(field);
      }

      if (isFunction(callback)) {
        return callback(record[field]);
      }

      return attr.mapping(record[field]);
    }
  }]);

  return Attr;
}();

export default Attr;