import { ScaleConfig } from '@antv/scale';
import Component from '../base/component';
import InteractionMixin from '../mixins/interaction';
import Coord from '../coord';
import ScaleController from '../controller/scale';
import InteractionController from '../controller/interaction';
interface Point {
    x: number;
    y: number;
}
interface Props {
    data: any;
    scale?: any;
    coord?: any;
    start?: Point;
    end?: Point;
    children: any;
}
interface IChart {
    props: Props;
}
export interface PositionLayout {
    position: 'top' | 'right' | 'bottom' | 'left';
    width: number;
    height: number;
}
export interface ComponentPosition {
    component: Component;
    layout: PositionLayout | PositionLayout[];
}
declare class Chart extends Component implements IChart, InteractionMixin {
    data: any;
    private layout;
    private coord;
    private componentsPosition;
    interaction: InteractionController;
    createInteractionController: ({ chart: any }: {
        chart: any;
    }) => any;
    setInteraction: (type: any, cfg: any) => any;
    private layoutController;
    private coordController;
    private scaleController;
    scale: ScaleController;
    constructor(props: any, context?: any, updater?: any);
    willReceiveProps(nextProps: any): void;
    willUpdate(): void;
    private getStyle;
    layoutCoord(layout: PositionLayout): void;
    resetCoordLayout(): void;
    updateCoordLayout(layout: PositionLayout | PositionLayout[]): void;
    updateCoordFor(component: Component, layout: PositionLayout | PositionLayout[]): void;
    getGeometrys(): Component<any, any>[];
    /**
     * calculate dataset's position on canvas
     * @param  {Object} record the dataset
     * @return {Object} return the position
     */
    getPosition(record: any): any;
    getSnapRecords(point: any): any;
    getLegendItems(point?: any): any;
    setScale(field: string, option: ScaleConfig): void;
    getScale(field: string): import("@antv/scale").Scale;
    getScales(): {
        [field: string]: import("@antv/scale").Scale;
    };
    getXScales(): any[];
    getYScales(): any[];
    getCoord(): Coord;
    filter(field: string, condition: any): void;
    _getRenderData(): any;
    render(): JSX.Element;
}
declare class ExportChart extends Chart {
}
export default ExportChart;
