"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _util = require("@antv/util");

var _jsx = require("../../jsx");

var Marker = function Marker(_ref) {
  var type = _ref.type,
      color = _ref.color;

  if (type === 'square') {
    return (0, _jsx.jsx)("rect", {
      style: {
        width: '12px',
        height: '12px',
        marginRight: '10px'
      },
      attrs: {
        fill: color
      }
    });
  }

  return (0, _jsx.jsx)("circle", {
    style: {
      width: '12px',
      height: '12px',
      marginRight: '10px'
    },
    attrs: {
      fill: color
    }
  });
};

var _default = function _default(props) {
  var items = props.items,
      itemWidth = props.itemWidth,
      itemFormatter = props.itemFormatter,
      style = props.style,
      _props$marker = props.marker,
      marker = _props$marker === void 0 ? 'circle' : _props$marker;

  var formatValue = function formatValue(value) {
    if ((0, _util.isFunction)(itemFormatter)) {
      return ": ".concat(itemFormatter(value));
    }

    return ": ".concat(value);
  };

  return (0, _jsx.jsx)("group", {
    style: style
  }, items.map(function (item) {
    var color = item.color,
        name = item.name,
        value = item.value,
        filtered = item.filtered;
    return (0, _jsx.jsx)("group", {
      className: "legend-item",
      style: {
        width: itemWidth,
        display: 'flex',
        flexDirection: 'row',
        alignItems: 'center',
        justifyContent: 'flex-start',
        padding: ['6px', '6px', '6px', 0]
      },
      "data-item": item
    }, (0, _jsx.jsx)(Marker, {
      color: filtered ? '#bfbfbf' : color,
      type: marker
    }), (0, _jsx.jsx)("text", {
      attrs: {
        fill: filtered ? '#bfbfbf' : '#808080',
        text: name
      }
    }), value ? (0, _jsx.jsx)("text", {
      attrs: {
        fill: '#808080',
        text: formatValue(value)
      }
    }) : null);
  }));
};

exports.default = _default;