"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _objectSpread2 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread2"));

var _jsx = require("../../jsx");

var _default = function _default(props, context) {
  var sidePadding = props.sidePadding,
      lineStyle = props.lineStyle,
      anchorStyle = props.anchorStyle,
      labels = props.labels,
      label1OffsetY = props.label1OffsetY,
      label2OffsetY = props.label2OffsetY,
      triggerRef = props.triggerRef;
  var defaultTextAttrs = {
    x: 0,
    y: 0,
    fontSize: '24px',
    lineHeight: '24px',
    fill: '#808080'
  };
  return (0, _jsx.jsx)("group", {
    ref: triggerRef
  }, labels.map(function (label) {
    var y = label.y,
        fill = label.fill,
        _inflection = label._inflection,
        _anchor = label._anchor,
        origin = label.origin,
        label1 = label.label1,
        label2 = label.label2;
    var lastPoint = {
      x: label._side === 'left' ? sidePadding : context.width - sidePadding,
      y: y
    };
    var textAttrs = {
      textAlign: label._side === 'left' ? 'left' : 'right',
      x: label._side === 'left' ? sidePadding : context.width - sidePadding
    };
    var points = [_anchor, _inflection, lastPoint];
    return (0, _jsx.jsx)("group", null, (0, _jsx.jsx)("circle", {
      attrs: (0, _objectSpread2.default)({
        r: 2,
        x: _anchor.x,
        y: _anchor.y,
        fill: fill
      }, anchorStyle)
    }), (0, _jsx.jsx)("polyline", {
      attrs: (0, _objectSpread2.default)({
        points: points,
        lineWidth: 1,
        stroke: fill
      }, lineStyle)
    }), (0, _jsx.jsx)("text", {
      className: "click",
      attrs: (0, _objectSpread2.default)((0, _objectSpread2.default)((0, _objectSpread2.default)({}, defaultTextAttrs), {}, {
        textBaseline: 'bottom',
        y: y + label1OffsetY
      }, textAttrs), label1),
      data: origin
    }), (0, _jsx.jsx)("text", {
      className: "click",
      attrs: (0, _objectSpread2.default)((0, _objectSpread2.default)((0, _objectSpread2.default)({}, defaultTextAttrs), {}, {
        textBaseline: 'top',
        y: y + label2OffsetY
      }, textAttrs), label2),
      data: origin
    }));
  }));
};

exports.default = _default;