"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _objectSpread2 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread2"));

var _elementStatus = require("../elementStatus");

var _f2Graphic = require("@antv/f2-graphic");

function createClipElement(type, config) {
  return new _f2Graphic.Shape[type](config);
}

var _default = function _default(element, animation, nextAttrs, lastAttrs) {
  if (!animation) return null; // 获取shape的默认属性

  var status = element.get('status'); // const { appear, update, leave } = animationCfg;
  // const animation = status === ELEMENT_DELETE ? leave : ( lastAttrs ? update : appear );
  // if (!animation) return;

  var clip = animation.clip,
      start = animation.start,
      end = animation.end,
      easing = animation.easing,
      delay = animation.delay,
      duration = animation.duration;

  if (clip) {
    var type = clip.type,
        _start = clip.start;
    var clipElement = createClipElement(type, {
      attrs: _start
    }); // 默认用 animation 配置里的 easing 和 duration

    clip.easing = clip.easing || easing;
    clip.delay = typeof clip.delay === 'number' ? clip.delay : delay;
    clip.duration = clip.duration || duration;
    clip.element = clipElement;
  }

  var defaultAttrs = element.getDefaultAttrs();
  return (0, _objectSpread2.default)((0, _objectSpread2.default)({}, animation), {}, {
    start: (0, _objectSpread2.default)((0, _objectSpread2.default)((0, _objectSpread2.default)({}, defaultAttrs), lastAttrs), start),
    end: (0, _objectSpread2.default)((0, _objectSpread2.default)({}, status === _elementStatus.ELEMENT_DELETE ? null : nextAttrs), end)
  });
};

exports.default = _default;