"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _rect = _interopRequireDefault(require("./rect"));

var _line = _interopRequireDefault(require("./line"));

var _text = _interopRequireDefault(require("./text"));

var _circle = _interopRequireDefault(require("./circle"));

var _marker = _interopRequireDefault(require("./marker"));

var map = {
  rect: _rect.default,
  line: _line.default,
  text: _text.default,
  circle: _circle.default,
  marker: _marker.default,
  group: _rect.default
};

var _default = function _default(type, layout) {
  if (!layout) return null;
  var fn = map[type] || _rect.default;
  return fn(layout);
};

exports.default = _default;